#import <Foundation/Foundation.h>
#import <Quartz/Quartz.h>
#include <stdio.h>

void printNSString (NSString *str)
{
   fputs([str cStringUsingEncoding:NSASCIIStringEncoding], stdout);
}

int main (int argc, const char * argv[])
{
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

   int a;
   for(a=1; a<argc; ++a){
      NSString * filename = [NSString stringWithCString: argv[a] encoding: NSASCIIStringEncoding];
      NSURL * url = [NSURL fileURLWithPath: filename];
      PDFDocument * doc = [[PDFDocument alloc] initWithURL: url];
      NSUInteger p, pages;
      if(doc==NULL){
         printNSString([NSString stringWithFormat: @"\nCould not load PDF file specified as '%@'\n", filename]);
         continue;
      }
      printNSString([NSString stringWithFormat: @"\nPDF File: '%@'\n", filename]);
      pages = [doc pageCount];
      for(p=0; p<pages; ++p){
         PDFPage * page = [doc pageAtIndex:p];
         NSArray * annotations = [page annotations];
         NSUInteger i;
         for(i=0; i<[annotations count]; ++i){
            PDFAnnotation * unknown_annotation = [annotations objectAtIndex:i];
            if([[unknown_annotation type] compare:@"Popup"]==NSOrderedSame) continue; // irrelevant
            if([[unknown_annotation type] compare:@"Link"]==NSOrderedSame) continue; // irrelevant
            NSString * context = @"";
            if([[unknown_annotation type] compare:@"Text"]==NSOrderedSame){
               PDFSelection * selection = [page selectionForRect:[unknown_annotation bounds]];
               [selection extendSelectionAtStart:10];
               [selection extendSelectionAtEnd:10];
               context = [[selection string] stringByReplacingOccurrencesOfString:@"\n" withString:@" "];
            }else{
               PDFSelection * selection = [page selectionForRect:[unknown_annotation bounds]];
               context = [[selection string] stringByReplacingOccurrencesOfString:@"\n" withString:@" "];
            }
            printNSString([NSString stringWithFormat: @"page %lu (%@), in context '%@':\n  %@\n",
                                                      p+1, [unknown_annotation type],
                                                      context,
                                                      [unknown_annotation contents]]);
         }
      }
      [doc release];
   }
   
   [pool drain];
   return 0;
}
